"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Components:
const React = require("react");
const classnames_1 = require("classnames");
const getClassNames_1 = require("../../utils/getClassNames");
exports.Button = React.memo(props => {
    const { bg, btnProps, children, className, disabled, inline, loading, onClick, outLine, style, type } = props, styleProps = __rest(props
    // Hook:
    , ["bg", "btnProps", "children", "className", "disabled", "inline", "loading", "onClick", "outLine", "style", "type"]);
    // Hook:
    const btnRef = React.useRef(null);
    // Styles:
    const display = inline ? 'inline-block' : 'block';
    let border = 'border-0';
    let background = 'bg-transparent';
    let text = 'text-text';
    switch (true) {
        case outLine:
            background = `bg-transparent hover:bg-${bg}`;
            text = `text-${bg} hover:text-white`;
            border = `border-2 border-${bg}`;
            break;
        case inline:
            background = 'bg-transparent';
            text = `text-${bg} hover:underline`;
            break;
        default:
            background = `bg-${bg} hover:bg-${bg}-dark`;
            text = 'text-white';
    }
    if (disabled) {
        text = 'text-white';
        background = 'bg-grey cursor-not-allowed';
        border = 'border-0';
    }
    const styleOptions = [background, border, display, text];
    const createRipple = (e) => {
        const btn = btnRef.current;
        if (btn) {
            if (btn.getElementsByClassName('Button-ripple').length > 0) {
                btn.getElementsByClassName('Button-ripple')[0].remove();
            }
            const circle = document.createElement('div');
            btn.appendChild(circle);
            const rect = btn.getBoundingClientRect();
            const d = Math.max(btn.clientHeight, btn.clientWidth);
            circle.style.width = circle.style.height = d + 'px';
            circle.style.left = e.clientX - rect.left - d / 2 + 'px';
            circle.style.top = e.clientY - rect.top - d / 2 + 'px';
            circle.classList.add('Button-ripple');
        }
    };
    const handleClick = (e) => {
        if (!disabled && !loading) {
            createRipple(e);
            onClick && onClick();
        }
    };
    return (React.createElement("button", Object.assign({ className: classnames_1.default('Button focus:outline-none transition overflow-hidden relative', loading && 'spinner', styleOptions, getClassNames_1.getClassNames(styleProps), className && className), onClick: handleClick, ref: btnRef, style: style && style, type: type }, btnProps), !loading && children));
});
exports.Button.defaultProps = {
    bg: 'first',
    type: 'button'
};
